/*
 * bg.h
 *
 * Last modified: <2009/11/15 11:15:45 +0900> By SUMIDA
 */
#ifndef BG_H_INCLUDED
#define BG_H_INCLUDED

/* }bvTCY */
#define BG_MAP_RESERVE	2
#define BG_MAP_SIZE   	32
#define BG_MAP_WIDTH  	(WIDTH/BG_MAP_SIZE)
#define BG_MAP_HEIGHT 	(HEIGHT/BG_MAP_SIZE)

#define FONT_MAP_RESERVE	2
#define FONT_MAP_SIZE   	16
#define FONT_MAP_WIDTH  	(WIDTH/FONT_MAP_SIZE)
#define FONT_MAP_HEIGHT 	(HEIGHT/FONT_MAP_SIZE)

/* BG */
#define BG_MAX 4

typedef struct MAP_ATTR {

	int surface_id;
	int map_id;
} MAP_ATTR;

typedef struct BG {

	//int priority;
	int ofs_x;
	int ofs_y;

	MAP_ATTR map[BG_MAP_HEIGHT + BG_MAP_RESERVE][BG_MAP_WIDTH + BG_MAP_RESERVE];
} BG;

typedef struct FONTMAP {

	int default_tex_id;
	int tex_id;

	//int priority;
	int ofs_x;
	int ofs_y;

	int font_x;
	int font_y;
	int frame_x;
	int frame_y;
	int frame_w;
	int frame_h;

	int options;

	MAP_ATTR map[FONT_MAP_HEIGHT + FONT_MAP_RESERVE][FONT_MAP_WIDTH + FONT_MAP_RESERVE];
} FONTMAP;


extern BG bg[BG_MAX];
extern void bg_init(void);
extern void bg_rendaring(SDL_Surface *screen, int bg_no);
extern void font_init(void);
extern void font_clean(void);
extern void font_texture(int tex_id);
extern void font_default_texture(void);
extern void font_rendaring(SDL_Surface *screen);
extern void font_frame(int x, int y, int w, int h);
extern void font_default_frame(void);
extern void font_attribute(int use);
extern void font_locate(int x, int y);
extern void font_printf(const char *format, ...);

#endif
