/*
 * boss1.c
 *
 * Last modified: <2009/11/24 06:48:15 +0900> By SUMIDA
 */
#include <math.h>
#include <SDL.h>
#include "system.h"
#include "texture.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "effect.h"

#define SHIP_FLAG_MOVE_MASK    0x0300
#define SHIP_FLAG_MOVE_LEFT    0x0100
#define SHIP_FLAG_MOVE_RIGHT   0x0200

#define SHIP_ACT_MASK          0x00FF
#define SHIP_ACT_MOVE          0x0001
#define SHIP_ACT_RUSH          0x0002
#define SHIP_ACT_BACK          0x0004
#define SHIP_ACT_CHARGE        0x0008
#define SHIP_ACT_DISCHARGE     0x0010

extern unsigned int frame_count;


/* NOTE : {X̍s

		SHIP_STAT_APPEAR = o

	SHIP_ACT_MOVE|
	SHIP_FLAG_MOVE_LEFT/SHIP_FLAG_MOVE_RIGHT
		SHIP_STAT_MOVE   = EړA5waye
		SHIP_STAT_NORMAL = ҋ@AEhe
		SHIP_STAT_FIRE   = [U[Vbg
	SHIP_ACT_RUSH
		SHIP_STAT_FIRE = ތːi
	SHIP_ACT_BACK
		SHIP_STAT_NORMAL = ޑҋ@AgUe

	SHIP_ACT_CHARGE
		SHIP_STAT_MOVE   = @ʈړ
		SHIP_STAT_NORMAL = ҋ@
	SHIP_ACT_DISCHARGE
		SHIP_STAT_FIRE   = [U[
		SHIP_STAT_NORMAL = ҋ@

	ȌAJԂB

	ŏ̍Eړ́AXRÂQڂ̒l̎AړJnB
	Qڈȍ~̓_B
	Eړ̓_ŕsB
	E̓ւ́Aʒ[ɓBB
 */

void boss1_init(SHIP_INFO *info) {

	REPORT(format("info=%p, id=%d", info, info->id));
	system_info.status |= SYSTEM_STAT_BOSS1;
	info->flag |= SHIP_FLAG_NODAMAGE|SHIP_FLAG_HEAVY|SHIP_FLAG_NOCLIP;
	info->count = 250;
	/*info->count = 181;/**/
	info->sprite.options |= 20;
	info->sprite.dy = IntToReal(2)>>1;
}

#include "bg.h"
void boss1(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship) {

	if (info->sprite.dy < 0 && info->sprite.y < IntToReal(-HEIGHT)) {
		/* ߂͐ */
		info->sprite.y = IntToReal(-HEIGHT);
	}

//	font_locate(0, 5);
//	font_printf("STAT:%03d", info->stat);

	switch (info->stat) {
	case SHIP_STAT_APPEAR:
		//REPORT("SHIP_STAT_APPEAR");
		if (info->count < 0) {
			if (info->sprite.y < IntToReal(0)) {
				info->count = 5;
				info->sprite.dx = 0;
				info->sprite.dy = IntToReal(2)>>1;
				break;
			}

			info->flag &= ~(SHIP_FLAG_NODAMAGE|SHIP_FLAG_USERS);
			info->stat = SHIP_STAT_MOVE;
			info->count = 60;
			info->sprite.dy = 0;

			/* XRA2ڂɂčŏ̕߂ */
			if ((system_info.score / 10 % 10) & 0x01) {
				info->sprite.dx = IntToReal(2);
				info->flag |= SHIP_ACT_MOVE|SHIP_FLAG_MOVE_RIGHT;
			} else {
				info->sprite.dx = -IntToReal(2);
				info->flag |= SHIP_ACT_MOVE|SHIP_FLAG_MOVE_LEFT;
			}
		}
		break;

	case SHIP_STAT_MOVE:
		//REPORT("SHIP_STAT_MOVE");
		if (info->count < 0) {
			/* Ԃ玟̃ANV */
			info->stat = SHIP_STAT_NORMAL;
			info->sprite.dx = 0;
			info->count = 60 * 2;
		}

		if (info->flag & SHIP_ACT_MOVE) {

			if (info->sprite.dx < 0 && info->sprite.x < 0) {
				/* ʒ[Ŕ] */
				info->flag &= ~SHIP_FLAG_MOVE_MASK;
				info->flag |= SHIP_FLAG_MOVE_LEFT;
				info->sprite.dx = -info->sprite.dx;

			} else {
				SURFACE *surface_info = surface_get(info->sprite.surface_id);

				if (info->sprite.dx > 0 && info->sprite.x + IntToReal(surface_info->frame_width) > IntToReal(WIDTH)) {
					/* ʒ[Ŕ] */
					info->flag &= ~SHIP_FLAG_MOVE_MASK;
					info->flag |= SHIP_FLAG_MOVE_RIGHT;
					info->sprite.dx = -info->sprite.dx;
				}
			}

		} else {

			SURFACE *surface_info = surface_get(info->sprite.surface_id);
			SURFACE *surface_ship = surface_get(ship->sprite.surface_id);

			Real x0 = info->sprite.x + (IntToReal(surface_info->frame_width)>>1);
			Real x1 = ship->sprite.x + (IntToReal(surface_ship->frame_width)>>1);
			Real dx = x1 - x0;

			if (-8 > dx || dx > 8) {
				/* @ɕύX */
				info->sprite.dx = -info->sprite.dx;
			} else {
				/* ̃ANV */
				info->sprite.dx = 0;
				info->count = 60 * 1;
				info->stat = SHIP_STAT_NORMAL;
			}
		}
		break;

	case SHIP_STAT_NORMAL:
		//REPORT("SHIP_STAT_NORMAL");
		if (info->count < 0) {
			info->sprite.dx = 0;
			info->count = 5;

			if (info->flag & (SHIP_ACT_BACK|SHIP_ACT_DISCHARGE)) {

				if (info->sprite.y < IntToReal(-16)) {

					int rnd = (int)Random(-3, 3);

					info->flag &= ~SHIP_FLAG_USERS;
					info->stat = SHIP_STAT_MOVE;
					info->sprite.dy = 0;

					if (rnd < 0) {
						info->flag |= SHIP_ACT_MOVE|SHIP_FLAG_MOVE_LEFT;
						info->sprite.dx = -IntToReal(2);
						info->count = 120;

					} else if (rnd > 0) {
						info->flag |= SHIP_ACT_MOVE|SHIP_FLAG_MOVE_RIGHT;
						info->sprite.dx = IntToReal(2);
						info->count = 120;

					} else {
						info->flag |= SHIP_ACT_CHARGE;
					}
				}

				

			} else if (info->flag & SHIP_ACT_CHARGE) {

				info->stat = SHIP_STAT_FIRE;
				info->flag &= ~SHIP_ACT_MASK;
				info->flag |= SHIP_ACT_DISCHARGE;
				info->sprite.dy = -IntToReal(1)>>1;

			} else {
				info->stat = SHIP_STAT_FIRE;

				/* [U[VbgƓːȋI */
				if (system_info.level > 7 && Random(0, 4) < 1) {
					info->flag &= ~SHIP_ACT_MASK;
					info->flag |= SHIP_ACT_RUSH;
					info->sprite.dy = -IntToReal(1)>>1;
				}
			}

		} else if (info->flag & SHIP_ACT_DISCHARGE) {
			if (info->count % 3 == 0) {

				/* 5waye */
				double angle = sprite_get_angle(&info->sprite, &ship->sprite);
				shot_5way(info, shot_mgr, 0, 0, angle, IntToReal(2));
			}

		} else if (info->flag & SHIP_ACT_BACK) {
			if (info->count % 3 == 0) {

				/* 3waye */
				double angle = (frame_count % 8) * 45;
				shot_3way(info, shot_mgr, 0, 0, angle, IntToReal(2));
			}

		} else {

			if (info->count % 3 == 0) {
				/* ΂Te */
				int c = info->count * 5;
				double angle = 90 - c;
				shot_3way(info, shot_mgr, 0, 0, angle, IntToReal(2));
			}
		}
		break;

	case SHIP_STAT_FIRE:
		//REPORT("SHIP_STAT_FIRE");
		if (info->count < 0) {

			info->count = 5;

			if (info->flag & SHIP_ACT_RUSH) {

				if (info->sprite.dy < 0 && info->sprite.y < -IntToReal(64)) {
					info->sprite.dx = 0;
					info->sprite.dy = IntToReal(4);

				} else if (info->sprite.dy > 0 && info->sprite.y > IntToReal(HEIGHT - 16)) {
					info->flag &= ~SHIP_ACT_MASK;
					info->flag |= SHIP_ACT_BACK;
					info->stat = SHIP_STAT_NORMAL;
					info->count = 60 * 1;
					info->sprite.dx = 0;
					info->sprite.dy = -IntToReal(1);

				} else {
						/* @Zo */
						double angle = sprite_get_angle(&info->sprite, &ship->sprite);
						SHOT_INFO *shot = shot_new(shot_mgr, SHOT_ID_BALLET);

						if (shot != NULL) {
							shot_fire(shot, info, 0, 0);
							sprite_set_angle(&shot->sprite, angle, IntToReal(5)>>1);
						}
				}

			} else if (info->flag & SHIP_ACT_DISCHARGE) {

				/* [U[̔ */
				SHOT_INFO *shot = shot_new(shot_mgr, SHOT_ID_RAY2);

				if (shot != NULL) {
					shot_fire(shot, info, 0, IntToReal(64));
					shot->sprite.dy = IntToReal(6);
				}

				if (Random(-2, 18) > system_info.level) {
					info->stat = SHIP_STAT_NORMAL;
					info->count = 60 * 2;
					//info->sprite.dy = IntToReal(-1)>>1;
					info->sprite.dy = 0;
				}

			} else /*if (Random(0, 16) <= system_info.level)*/ {
				/* [U[Vbg̔ */
				SHOT_INFO *shot1 = shot_new(shot_mgr, SHOT_ID_RAY3);
				SHOT_INFO *shot2 = shot_new(shot_mgr, SHOT_ID_RAY3);
				SHOT_INFO *shot3 = shot_new(shot_mgr, SHOT_ID_RAY3);
				SHOT_INFO *shot4 = shot_new(shot_mgr, SHOT_ID_RAY3);
				Real spd = IntToReal((system_info.level >> 1) + 1);

				if (shot1 != NULL) {
					shot_fire(shot1, info, IntToReal(-34), IntToReal(-20));
					shot1->sprite.dy = spd;
				}

				if (shot2 != NULL) {
					shot_fire(shot2, info, IntToReal(34), IntToReal(-20));
					shot2->sprite.dy = spd;
				}

				if (shot3 != NULL) {
					shot_fire(shot3, info, IntToReal(-18), IntToReal(-4));
					shot3->sprite.dy = spd;
				}

				if (shot4 != NULL) {
					shot_fire(shot4, info, IntToReal(18), IntToReal(-4));
					shot4->sprite.dy = spd;
				}

				if (Random(-4, 18) > system_info.level) {
					info->stat = SHIP_STAT_MOVE;
					info->count = 60 * 3;
					info->sprite.dy = 0;

					/* tړ */
					if (info->flag & SHIP_FLAG_MOVE_LEFT) {
						info->sprite.dx = IntToReal(2);
						info->flag &= ~SHIP_FLAG_MOVE_MASK;
						info->flag |= SHIP_ACT_MOVE|SHIP_FLAG_MOVE_RIGHT;
					} else {
						info->sprite.dx = -IntToReal(2);
						info->flag &= ~SHIP_FLAG_MOVE_MASK;
						info->flag |= SHIP_ACT_MOVE|SHIP_FLAG_MOVE_LEFT;
					}
				}
			}
		}
		break;

	default:
		break;
	}
}

void boss1_term(SHIP_INFO *info) {

	REPORT(format("info=%p", info));
	system_info.status &= ~SYSTEM_STAT_BOSS1;
}
