/*
 * draw.c
 *
 * hsv_to_rgb()ȊÓASDL_Draw.c̉ϔŁB
 * 32bitJ[̗plĂȂB
 * http://hp.vector.co.jp/authors/VA028002/sdl/index.html
 *
 * Last modified: <2009/11/29 22:28:14 +0900> By SUMIDA
 */
#include <SDL.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "system.h"
#include "draw.h"

#define SWAP(_type, _a, _b) {_type _c; _c = _a; _a = _b; _b = _c;}

/* XN[T[tFX */
extern SDL_Surface *screen;

/* `` */
static void draw_rect_(unsigned int frameBuf[HEIGHT][WIDTH],
					  int x1, int y1, int x2, int y2, unsigned int color);
static void draw_trect_(unsigned int frameBuf[HEIGHT][WIDTH],
					  int x1, int y1, int x2, int y2, unsigned int color);
static void draw_srect_(unsigned int frameBuf[HEIGHT][WIDTH],
					  int x1, int y1, int x2, int y2, unsigned int color);

/* lp`` */
static void draw_box_(unsigned int frameBuf[HEIGHT][WIDTH],
					 int x1, int y1, int x2, int y2, unsigned int color);

/* C` */
static void draw_line_(unsigned int frameBuf[HEIGHT][WIDTH],
					  int x1, int y1, int x2, int y2, unsigned int color);

/* T[N` */
static void draw_circle_(unsigned int frameBuf[HEIGHT][WIDTH],
						int x1, int y1, int x2, int y2, unsigned int color);

/* hԂ */
static void draw_paint_(unsigned int frameBuf[HEIGHT][WIDTH],
					   int x, int y, unsigned int color);


void draw_circle(int x, int y, int r, int w, unsigned int color) {


	int i;

	for (i = 0, r -= w / 2; i < w; i++, r++) {

		int x1 = x - r;
		int x2 = x + r;
		int y1 = y - r;
		int y2 = y + r;

		draw_circle_(screen->pixels, x1, y1, x2, y2, color);
	}
}

void draw_rect(int x1, int y1, int x2, int y2, unsigned int color) {
	draw_rect_(screen->pixels, x1, y1, x2, y2, color);
}
void draw_trect(int x1, int y1, int x2, int y2, unsigned int color) {
	draw_trect_(screen->pixels, x1, y1, x2, y2, color);
}
void draw_srect(int x1, int y1, int x2, int y2, unsigned int color) {
	draw_srect_(screen->pixels, x1, y1, x2, y2, color);
}

void draw_line(int x1, int y1, int x2, int y2, int w, unsigned int color) {

	int i;

	if (abs(y1 - y2) <= w) {
		for (i = 0, y1 -= w / 2, y2 -= w / 2;
			 i < w;
			 i++, y1++, y2++) {
			draw_line_(screen->pixels, x1, y1, x2, y2, color);
		}
	} else {
		for (i = 0, x1 -= w / 2, x2 -= w / 2;
			 i < w;
			 i++, x1++, x2++) {
			draw_line_(screen->pixels, x1, y1, x2, y2, color);
		}
	}
}

/*****************************************************************************/
/* ``                                                                  */
/*****************************************************************************/
void draw_rect_(unsigned int frameBuf[HEIGHT][WIDTH],
			   int x1, int y1, int x2, int y2, unsigned int color) {

	int x, y;

	if (x1 > x2) SWAP(int, x1, x2);
	if (y1 > y2) SWAP(int, y1, y2);

	if (x1 < 0) x1 = 0;
	if (y1 < 0) y1 = 0;
	if (x2 > WIDTH ) x2 = WIDTH - 1;
	if (y2 > HEIGHT) y2 = HEIGHT -1;

	for (y = y1; y <= y2; y++) {

		unsigned int *line = &frameBuf[y][x1];

		for (x = x1; x <= x2; x++) {

			*line++ = color;
		}
	}
}

/*****************************************************************************/
/* ߋ``                                                              */
/*****************************************************************************/
void draw_trect_(unsigned int frameBuf[HEIGHT][WIDTH],
			   int x1, int y1, int x2, int y2, unsigned int color) {

	unsigned int t =   (color >> 24) & 0xff;
	unsigned int r0 = ((color >> 16) & 0xff) * t >> 8;
	unsigned int g0 = ((color >>  8) & 0xff) * t >> 8;
	unsigned int b0 = ( color        & 0xff) * t >> 8;
	int x, y;

	if (x1 > x2) SWAP(int, x1, x2);
	if (y1 > y2) SWAP(int, y1, y2);

	if (x1 < 0) x1 = 0;
	if (y1 < 0) y1 = 0;
	if (x2 > WIDTH ) x2 = WIDTH - 1;
	if (y2 > HEIGHT) y2 = HEIGHT -1;

	for (y = y1; y <= y2; y++) {

		unsigned int *line = &frameBuf[y][x1];

		for (x = x1; x <= x2; x++) {
			unsigned int p = *line;
			unsigned int r = ((p >> 16) & 0xff) + r0;
			unsigned int g = ((p >>  8) & 0xff) + g0;
			unsigned int b = ( p        & 0xff) + b0;
			if (r > 0xff) r = 0xff;
			if (g > 0xff) g = 0xff;
			if (b > 0xff) b = 0xff;
			*line++ = (r << 16) | (g << 8) | b;
		}
	}
}

/*****************************************************************************/
/* wiߋ``                                                          */
/*****************************************************************************/
void draw_srect_(unsigned int frameBuf[HEIGHT][WIDTH],
			   int x1, int y1, int x2, int y2, unsigned int color) {

	unsigned int t =  (color >> 24) & 0xff;
	unsigned int r0 = (color >> 16) & 0xff;
	unsigned int g0 = (color >>  8) & 0xff;
	unsigned int b0 =  color        & 0xff;
	int x, y;

	if (x1 > x2) SWAP(int, x1, x2);
	if (y1 > y2) SWAP(int, y1, y2);

	if (x1 < 0) x1 = 0;
	if (y1 < 0) y1 = 0;
	if (x2 > WIDTH ) x2 = WIDTH - 1;
	if (y2 > HEIGHT) y2 = HEIGHT -1;

	for (y = y1; y <= y2; y++) {

		unsigned int *line = &frameBuf[y][x1];

		for (x = x1; x <= x2; x++) {
			unsigned int p = *line;
			unsigned int r = (p >> 16) & 0xff;
			unsigned int g = (p >>  8) & 0xff;
			unsigned int b =  p        & 0xff;
			r = ((r * t) >> 8) + r0;
			g = ((g * t) >> 8) + g0;
			b = ((b * t) >> 8) + b0;
			if (r > 0xff) r = 0xff;
			if (g > 0xff) g = 0xff;
			if (b > 0xff) b = 0xff;
			*line++ = (r << 16) | (g << 8) | b;
		}
	}
}

/*****************************************************************************/
/* lp``                                                                */
/*****************************************************************************/
void draw_box_(unsigned int frameBuf[HEIGHT][WIDTH],
			  int x1, int y1, int x2, int y2, unsigned int color) {

	unsigned int *line1, *line2;
	int x, y;

	if (x1 > x2) SWAP(int, x1, x2);
	if (y1 > y2) SWAP(int, y1, y2);

	if (x1 < 0) x1 = 0;
	if (y1 < 0) y1 = 0;
	if (x2 > WIDTH ) x2 = WIDTH - 1;
	if (y2 > HEIGHT) y2 = HEIGHT -1;

	line1 = &frameBuf[y1][x1];
	line2 = &frameBuf[y2][x1];

	for (x = x1; x <= x2; x++) {
		*line1++ = color;
		*line2++ = color;
	}

	for (y = y1 + 1; y < y2; y++) {

		line1 = &frameBuf[y][x1];
		line2 = &frameBuf[y][x2];

		*line1 = *line2 = color;
	}
}

/*****************************************************************************/
/* C`                                                                */
/*****************************************************************************/
void draw_line_(unsigned int frameBuf[HEIGHT][WIDTH],
			   int x1, int y1, int x2, int y2, unsigned int color) {

	int dx, dy, dx2, dy2;
	int sx, sy;
	int i, l;
	int e;
/*
	if ( x1 < 0 || WIDTH <= x1 || x2 < 0 || WIDTH <= x2
		 || y1 < 0 || HEIGHT <= y1 || y2 < 0 || HEIGHT <= y2) return;
*/
/*
	if (x1 > x2) SWAP(int, x1, x2);
	if (y1 > y2) SWAP(int, y1, y2);
*/
	if (x1 < 0) x1 = 0;
	if (x2 < 0) x2 = 0;
	if (x1 >= WIDTH) x1 = WIDTH -1;
	if (x2 >= WIDTH) x2 = WIDTH -1;

	if (y1 < 0) y1 = 0;
	if (y2 < 0) y2 = 0;
	if (y1 >= HEIGHT) y1 = HEIGHT -1;
	if (y2 >= HEIGHT) y2 = HEIGHT -1;

	dx = (x2 < x1) ? x1 - x2 : x2 - x1;
	dy = (y2 < y1) ? y1 - y2 : y2 - y1;
	sx = (x2 < x1) ? -1 : 1;
	sy = (y2 < y1) ? -1 : 1;
	dx2 = dx * 2;
	dy2 = dy * 2;

	if (x1 == x2) {
		if (y1 < y2) {
			for (i = y1; i < y2; i++) {
				frameBuf[i][x1] = color;
			}
		} else {
			for (i = y2; i < y1; i++) {
				frameBuf[i][x1] = color;
			}
		}

	} else if (y1 == y2) {
		if (x1 < x2) {
			for (i = x1; i < x2; i++) {
				frameBuf[y1][i] = color;
			}
		} else {
			for(i = x2; i < x1; i++) {
				frameBuf[y1][i] = color;
			}
		}

	} else if(dx >= dy) {
		e = -dx;
		l = (dx + 1) / 2;
		for (i = 0;i < l;i++) {
			frameBuf[y1][x1] = color;
			frameBuf[y2][x2] = color;
			x1 += sx;
			x2 -= sx;
			e += dy2;
			if (e >= 0) {
				y1 += sy;
				y2 -= sy;
				e -= dx2;
			}
		}
		if (dx % 2 == 0) frameBuf[y1][x1] = color;

	} else {
		e = -dy;
		l = (dy + 1) / 2;
		for (i = 0; i < l; i++) {
			frameBuf[y1][x1] = color;
			frameBuf[y2][x2] = color;
			y1 += sy;
			y2 -= sy;
			e += dx2;
			if (e >= 0) {
				x1 += sx;
				x2 -= sx;
				e -= dy2;
			}
		}
		if (dy % 2 == 0) frameBuf[y1][x1] = color;
	}
}

/*****************************************************************************/
/* T[N`                                                              */
/*****************************************************************************/

void draw_point_(unsigned int frameBuf[HEIGHT][WIDTH],
				 int x, int y, unsigned int color) {

	if (x < 0 || WIDTH <= x || y < 0 || HEIGHT <= y) return;

	frameBuf[y][x] = color;
}


void draw_circle_(unsigned int frameBuf[HEIGHT][WIDTH],
				 int x1, int y1, int x2, int y2, unsigned int color) {

	int r;
	int dx, dy;
	int xa, ya, xb, yb;
	int f;
/*
	if ( x1 < 0 || WIDTH <= x1 || x2 < 0 || WIDTH <= x2
		 || y1 < 0 || HEIGHT <= y1 || y2 < 0 || HEIGHT <= y2) return;
*/
	if (x1 == x2 && y1 == y2) return;

	if (x1 > x2) {
		int tmp = x2;
		x2 = x1;
		x1 = tmp;
	}

	if (y1 > y2) {
		int tmp = y2;
		y2 = y1;
		y1 = tmp;
	}

	dx = (x2 < x1) ? x1 - x2 : x2 - x1;
	dy = (y2 < y1) ? y1 - y2 : y2 - y1;

	if (dx >= dy) {
		r = dx / 2;
		xa = r;
		ya = 0;
		f = 3 - 2 * r;
		x1 += dx / 2;
		y1 += dy / 2;
		x2 = x1 + dx % 2;
		y2 = y1 + dy % 2;

		while (xa >= ya) {
			xb = (xa * dy) / dx;
			yb = (ya * dy) / dx;
/*
			frameBuf[-yb + y1][ xa + x2] = color;
			frameBuf[-xb + y1][ ya + x2] = color;
			frameBuf[-xb + y1][-ya + x1] = color;
			frameBuf[-yb + y1][-xa + x1] = color;
			frameBuf[ yb + y2][-xa + x1] = color;
			frameBuf[ xb + y2][-ya + x1] = color;
			frameBuf[ xb + y2][ ya + x2] = color;
			frameBuf[ yb + y2][ xa + x2] = color;
*/
			draw_point_(frameBuf,  xa + x2, -yb + y1, color);
			draw_point_(frameBuf,  ya + x2, -xb + y1, color);
			draw_point_(frameBuf, -ya + x1, -xb + y1, color);
			draw_point_(frameBuf, -xa + x1, -yb + y1, color);
			draw_point_(frameBuf, -xa + x1,  yb + y2, color);
			draw_point_(frameBuf, -ya + x1,  xb + y2, color);
			draw_point_(frameBuf,  ya + x2,  xb + y2, color);
			draw_point_(frameBuf,  xa + x2,  yb + y2, color);

			if (f >= 0) {
				xa--;
				f -= 4 * xa;
			}

			ya++;
			f += 4 * ya + 2;
		}

	} else {
		r = dy / 2;
		ya = r;
		xa = 0;
		f = 3 - 2 * r;
		x1 += dx / 2;
		y1 += dy / 2;
		x2 = x1 + dx % 2;
		y2 = y1 + dy % 2;

		while (ya >= xa) {
			xb = (xa * dx) / dy;
			yb = (ya * dx) / dy;
/*
			frameBuf[-ya + y1][ xb + x2] = color;
			frameBuf[-xa + y1][ yb + x2] = color;
			frameBuf[-xa + y1][-yb + x1] = color;
			frameBuf[-ya + y1][-xb + x1] = color;
			frameBuf[ ya + y2][-xb + x1] = color;
			frameBuf[ xa + y2][-yb + x1] = color;
			frameBuf[ xa + y2][ yb + x2] = color;
			frameBuf[ ya + y2][ xb + x2] = color;
*/
			draw_point_(frameBuf,  xb + x2, -ya + y1, color);
			draw_point_(frameBuf,  yb + x2, -xa + y1, color);
			draw_point_(frameBuf, -yb + x1, -xa + y1, color);
			draw_point_(frameBuf, -xb + x1, -ya + y1, color);
			draw_point_(frameBuf, -xb + x1,  ya + y2, color);
			draw_point_(frameBuf, -yb + x1,  xa + y2, color);
			draw_point_(frameBuf,  yb + x2,  xa + y2, color);
			draw_point_(frameBuf,  xb + x2,  ya + y2, color);

			if (f >= 0) {
				ya--;
				f -= 4 * ya;
			}

			xa++;
			f += 4 * xa + 2;
		}
	}
}

/*****************************************************************************/
/* hԂ                                                                */
/*****************************************************************************/
void draw_paint_(unsigned int frameBuf[HEIGHT][WIDTH],
				int x, int y, unsigned int color) {

	static struct point {int x; int y;} buffer[WIDTH + 1];

	int pbuf;
	unsigned int bcol;
	int i;
	int bx1, bx2, by;

	if ( x < 0 || WIDTH <= x || y < 0 || HEIGHT <= y) return;

	bcol = frameBuf[y][x];

	if (bcol == color) return;

	buffer[0].x = x;
	buffer[0].y = y;
	pbuf = 1;

	while (pbuf) {
		pbuf--;
		bx1 = bx2 = buffer[pbuf].x;
		by = buffer[pbuf].y;

		while (bx1 >= 0    && frameBuf[by][bx1] == bcol) bx1--;
		while (bx2 < WIDTH && frameBuf[by][bx2] == bcol) bx2++;

		bx1++;
		bx2--;

		for (i = bx1; i <= bx2; i++) {
			frameBuf[by][i] = color;
		}

		if (by > 0) {
			i = bx1;
			by--;

			if (frameBuf[by][i] == bcol) {
				while(i >= 0 && frameBuf[by][i] == bcol) i--;
				i++;
			} else {
				while(i <= bx2 && frameBuf[by][i] != bcol) i++;
			}

			while (i <= bx2) {
				buffer[pbuf].x = i;
				buffer[pbuf].y = by;
				pbuf++;

				while (i < WIDTH && frameBuf[by][i] == bcol) i++;
				while (i <= bx2  && frameBuf[by][i] != bcol) i++;
			}

		} else {
			by--;
		}

		if (by + 2 < HEIGHT) {
			i = bx1;
			by += 2;

			if (frameBuf[by][i] == bcol) {
				while(i >= 0 && frameBuf[by][i] == bcol) i--;
				i++;

			} else {
				while (i <= bx2 && frameBuf[by][i] != bcol) i++;
			}

			while (i <= bx2) {
				buffer[pbuf].x = i;
				buffer[pbuf].y = by;
				pbuf++;

				while (i < WIDTH && frameBuf[by][i] == bcol) i++;
				while (i <= bx2  && frameBuf[by][i] != bcol) i++;
			}
		}
	}
}

/*****************************************************************************/
/* HSV  RGB                                                                */
/*****************************************************************************/
void hsv_to_rgb(double h, double s, double v, int *r, int *g, int *b) {

	while (h <    0) h = h + 360;
	while (h >= 360) h = h - 360;

	if (s == 0 || s > 1.0) {
		*r = *g = *b = (int)(v * 255);

	} else {
		double dr, dg, db;

		double d = h / 60;
		int i = (int)d;
		double f = d - i;
		double m = v * (1 - s);
		double n = v * (1 - s * f);
		double k = v * (1 - s * (1 - f));

		switch (i) {
		default:
		case 0:
			dr = v, dg = k, db = m;
			break;
		case 1:
			dr = n, dg = v, db = m;
			break;
		case 2:
			dr = m, dg = v, db = k;
			break;
		case 3:
			dr = m, dg = n, db = v;
			break;
		case 4:
			dr = k, dg = m, db = v;
			break;
		case 5:
			dr = v, dg = m, db = n;
			break;
		}

		*r = (int)(dr * 255);
		*g = (int)(dg * 255);
		*b = (int)(db * 255);
	}
}

