/*
 * enemy1.c
 *
 * Last modified: <2009/08/31 22:08:53 +0900> By SUMIDA
 */
#include <SDL.h>
#include <math.h>
#include "system.h"
#include "texture.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "effect.h"
#include "sound.h"

#define FLAG_SEARCH 0x010000

static void enemy1_set_frame(SHIP_INFO *info);

void enemy1_init(SHIP_INFO *info) {

	REPORT(format("info=%p, id=%d", info, info->id));
	info->sprite.options |= 10;
	info->sprite.dy = IntToReal(3) >> 1;
}

void enemy1(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship) {

	/* ǐ */
	if ((info->flag & FLAG_SEARCH)
		&& ship->stat != SHIP_STAT_EXPLOSION && ship->stat != SHIP_STAT_LOST) {
		sprite_homing(&info->sprite, &ship->sprite, IntToReal(3) >> 1);
	}

	switch (info->stat) {
	case SHIP_STAT_APPEAR:
		if (info->count < 0) {
			info->count = 5;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	case SHIP_STAT_MOVE:
		if (info->count < 0) {
			info->count = 5;
			info->stat = SHIP_STAT_NORMAL;
		}
		break;

	case SHIP_STAT_NORMAL:
		if (info->count < 0 && Random(0, 128) < system_info.level) {
			info->count = 5;
			info->stat = SHIP_STAT_FIRE;
		}
		break;

	case SHIP_STAT_FIRE:
		if (info->count < 0 && Random(0, 128) < system_info.level) {
			/* _Pe̔ */
			SHOT_INFO *shot = shot_new(shot_mgr, SHOT_ID_BALLET);

			if (shot != NULL) {
				shot_fire(shot, info, 0, 0);
				shot_homing(shot, ship, IntToReal(1));
			}

			info->count = 5;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	default:
		break;
	}
#if 0
	/* ʒ[Ŕ] */
	if (info->sprite.dx < 0 && info->sprite.x < IntToReal(10)
		|| info->sprite.dx > 0 && info->sprite.x > IntToReal(WIDTH - 10)) {
		info->sprite.dx = -info->sprite.dx;
	}
#endif

	enemy1_set_frame(info);
}

void enemy1_term(SHIP_INFO *info) {
	REPORT(format("info=%p", info));
}

void enemy1_set_frame(SHIP_INFO *info) {

	/* ݂̌ɍ킹ăXvCg̃Aj[V͈͂ */
	int r = (int)(C_RAD_DEG(atan2(-info->sprite.dy, info->sprite.dx) - 22.5/2) / 22.5) % 16;
	int n = info->sprite.frame_no % 2;
	while (r < 0) r += 16;

	//REPORT(format("dx=%d, dy=%d, r=%d", info->sprite.dy, info->sprite.dx, r));

	info->sprite.frame_start = r * 2;
	info->sprite.frame_end = info->sprite.frame_start + 1;
	info->sprite.frame_no  = info->sprite.frame_start + n;
}
