/*
 * enemy2.c
 *
 * Last modified: <2009/06/24 15:24:36 +0900> By SUMIDA
 */
#include <SDL.h>
#include "system.h"
#include "texture.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "effect.h"

void enemy2_init(SHIP_INFO *info) {

	REPORT(format("info=%p, id=%d", info, info->id));
	info->sprite.options |= 11;
	info->sprite.dy = IntToReal(5) >> 1;
}

void enemy2(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship) {

	switch (info->stat) {
	case SHIP_STAT_APPEAR:
		/* ʒ[Ŕ] */
		if (info->sprite.dx < 0 && info->sprite.x < IntToReal(10)
			|| info->sprite.dx > 0 && info->sprite.x > IntToReal(WIDTH - 10)) {
			info->sprite.dx = -info->sprite.dx;
		}

		if (info->count < 0) {
			info->count = 60;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	case SHIP_STAT_MOVE:
		if (info->count < 0) {

			/* }] */
			sprite_set_angle(
				&info->sprite,
				sprite_get_angle(&info->sprite, &ship->sprite) - 180,
				IntToReal(4));

			info->count = 0;
			info->stat = SHIP_STAT_NORMAL;
		}
		break;

	case SHIP_STAT_NORMAL:
		if (Random(0, 128) < system_info.level) {
			info->count = 10;
			info->stat = SHIP_STAT_FIRE;
		}
		break;

	case SHIP_STAT_FIRE:
		if (info->count < 0 && Random(0, 128) < system_info.level) {
			/* QAe̔ */
			SHOT_INFO *shot1 = shot_new(shot_mgr, SHOT_ID_BALLET);
			SHOT_INFO *shot2 = shot_new(shot_mgr, SHOT_ID_BALLET);

			if (shot1 != NULL) {
				shot_fire(shot1, info, IntToReal(-6), 0);
				shot1->sprite.dy = IntToReal(3);
			}

			if (shot2 != NULL) {
				shot_fire(shot2, info, IntToReal(30), 0);
				shot2->sprite.dy = IntToReal(3);
			}

			info->count = 0;
			info->stat = SHIP_STAT_NORMAL;
		}
		break;

	default:
		return;
	}
}

void enemy2_term(SHIP_INFO *info) {
	REPORT(format("info=%p", info));
}
