/*
 * log.c
 *
 * Oo͗p̊֐Q
 *
 * Last modified: <2009/06/16 19:43:45 +0900> By SUMIDA
 */
#include <stdio.h>
#include <string.h>
#include "log.h"

/*
 * ֐
 *        w̃tH[}bgɏ]ȀB
 *        ɐÓÏێ邽߁AXbhZ[tł͂ȂB
 * F
 *        const char *fmt c tH[}bg
 *                    ... c ψ
 *
 * ߂lFւ̃|C^
 */
char *format(const char *fmt, ...) {

	static char buf[1024];

	va_list ap;
	va_start(ap, fmt);
	vsnprintf(buf, sizeof(buf), fmt, ap);
	va_end(ap);

	return buf;
}

/*
 * ݓ̕擾
 *        YYYY/MM/DD HH:MM:SS.SSS `œt擾B
 *        ɐÓÏێ邽߁AXbhZ[tł͂ȂB
 *
 * FȂ
 *
 * ߂lFt
 */
char *now(void) {

	static char buf[24];

	struct timeb now;
	struct tm *t;

	ftime(&now);
	t = localtime(&now.time);
	memset(buf, '\0', sizeof(buf));
	strftime(buf, sizeof(buf), "%Y/%m/%d %H:%M:%S", t);
	snprintf(&buf[19], 5, ".%03d", now.millitm);

	return buf;
}


/*
 * _v
 *        w|C^̃̈16i_vWo͂֏o͂B
 *
 * F
 *        const void *ptr c o̓f[^ւ̃|C^
 *        size_t     size c o̓TCY
 *
 * ߂lFȂ
 */
void dump(void *ptr, size_t size) {

	/* FIXED : 16io͂̎ */
	/* printf("%.*s", size, ptr);
	 */

	/* o͌`F
	 * 
	 * 0         1         2         3         4         5         6
	 * 01234567890123456789012345678901234567890123456789012345678901234
	 * xxxxxxxx: xxxxxxxxxxxxxxxx xxxxxxxxxxxxxxxx [ cccccccc cccccccc ]
	 */
	unsigned char *p = ptr;

	char buf[55];

	while (size > 0) {
		unsigned char *top = p;
		char *hex = &buf[0];
		char *asc = &buf[36];
		int max = (size > 16)? 16: size;
		int i;

		memset(buf, ' ', sizeof(buf));
		buf[34] = '[';
		buf[54] = ']';

		for (i = 0; i < max; i++) {
			unsigned char d = *p++;
			unsigned char d0, d1;

			if (d < 0x20) d = '.';
			if (i == 8) hex++, asc++;

			d0 = (d >> 4) & 0x0f;
			d1 = d & 0x0f;

			d0 = TO_ASC(d0);
			d1 = TO_ASC(d1);

			*hex++ = d0;
			*hex++ = d1;
			*asc++ = d;
		}

		printf("%0p: %s\n", top, buf);
		size -= max;
	}
}

