/*
 * ship.h
 *
 * Last modified: <2009/10/19 18:23:11 +0900> By SUMIDA
 */
#ifndef SHIP_H_INCLUDED
#define SHIP_H_INCLUDED

#include "sprite.h"

#define SHIP_DEF_LOST_WAIT  2

typedef enum SHIP_ID {

	SHIP_ID_ME = 0,
	SHIP_ID_ENEMY,
	SHIP_ID_ENEMY1 = SHIP_ID_ENEMY,
	SHIP_ID_ENEMY2,
	SHIP_ID_ENEMY3,
	SHIP_ID_ENEMY4,
	SHIP_ID_ENEMY5,
	SHIP_ID_MISSILE,
	SHIP_ID_ROCK,
	SHIP_ID_ROCK_M1,
	SHIP_ID_ROCK_M2,
	SHIP_ID_ROCK_M3,
	SHIP_ID_ROCK_S1,
	SHIP_ID_ROCK_S2,
	SHIP_ID_ROCK_S3,
	SHIP_ID_BOSS1,
	SHIP_ID_BOSS2,
	SHIP_ID_MAX
} SHIP_ID;

typedef enum SHIP_STAT {

	SHIP_STAT_LOST = 0,  /*      */
	SHIP_STAT_INIT,
	SHIP_STAT_APPEAR,    /* o     */
	SHIP_STAT_NORMAL,    /* ʏ */
	SHIP_STAT_MOVE,      /* ړ     */
	SHIP_STAT_FIRE,      /* C     */
	SHIP_STAT_EXPLOSION, /*      */
	SHIP_STAT_MAX
} SHIP_STAT;

typedef enum SHIP_FLAG {

	SHIP_FLAG_DOWN     = 0x01000000,    /* e               */
	SHIP_FLAG_HEAVY    = 0x02000000,    /* dʑ             */
	SHIP_FLAG_NODAMAGE = 0x04000000,    /* m[_[W       */
	SHIP_FLAG_LOCKON   = 0x08000000,    /* bNI         */
	SHIP_FLAG_NOCLIP   = 0x40000000,    /* ʊOłȂ     */
	SHIP_FLAG_NOPOOL   = 0x80000000,    /* v[Ȃ     */
	SHIP_FLAG_SYSTEM   = 0xff000000,    /* VXetO   */
	SHIP_FLAG_USERS = ~SHIP_FLAG_SYSTEM /* [UptO */
} SHIP_FLAG;

typedef struct SHIP_INFO {

	struct SHIP_INFO *next;
	int id;
	SPRITE sprite;
	SHIP_STAT stat;
	SHIP_FLAG flag;
	int count;
	int point;
	int strength;

} SHIP_INFO;

typedef struct SHIP_TYPE {
	int tex_id;
	int strength;
	int point;
	int lockon;
	Uint32 options;
	RealRect collision;
} SHIP_TYPE;

typedef struct SHIP_MGR {
	SHIP_INFO *active;
	SHIP_INFO *pool;
} SHIP_MGR;

extern void ship_init(SHIP_MGR *mgr, SHIP_INFO *infos, size_t number);

extern SHIP_INFO *ship_new(SHIP_MGR *mgr, SHIP_ID id);

extern void ship_delete(SHIP_MGR *mgr, SHIP_INFO *info, SHIP_INFO *prev);

extern int ship_down(SHIP_INFO *info, int *strength, Real dx, Real dy);

extern void ship_action(SHIP_MGR *mgr, SHIP_MGR *enemy_mgr);

#endif
