/*
 * shot.h
 *
 * Last modified: <2009/11/21 15:22:52 +0900> By SUMIDA
 */
#ifndef SHOT_H_INCLUDED
#define SHOT_H_INCLUDED

#include "ship.h"

#define SHOT_LIMIT_STRENGTH 10

typedef enum SHOT_ID {

	SHOT_ID_NORMAL = 0,
	SHOT_ID_BALLET,
	SHOT_ID_MBALLET,
	SHOT_ID_RAY1,
	SHOT_ID_RAY2,
	SHOT_ID_RAY3,
	SHOT_ID_PHOTON,
	SHOT_ID_PHOTON_S,
	SHOT_ID_PHOTON_D,
	SHOT_ID_MAX

} SHOT_ID;

typedef enum SHOT_STAT {

	SHOT_STAT_LOST = 0,      /*      */
	SHOT_STAT_NORMAL,        /* ʏ */
	SHOT_STAT_SEARCH,        /* T */
	SHOT_STAT_EXPLOSION,     /*      */
	SHOT_STAT_MAX

} SHOT_STAT;

typedef struct SHOT_INFO {

	struct SHOT_INFO *next;
	int id;
	SPRITE sprite;
	SHOT_STAT stat;
	int count;
	int strength;
	SHIP_INFO *target;

} SHOT_INFO;

typedef struct SHOT_MGR {
	SHOT_INFO *active;
	SHOT_INFO *pool;
} SHOT_MGR;

extern void shot_init(SHOT_MGR *mgr, SHOT_INFO *infos, size_t number);
extern SHOT_INFO *shot_new(SHOT_MGR *mgr, SHOT_ID id);
extern void shot_delete(SHOT_MGR *mgr, SHOT_INFO *info, SHOT_INFO *prev);
extern int shot_action(SHOT_MGR *mgr, SHIP_MGR *ship_mgr);
extern void shot_fire(SHOT_INFO *info, SHIP_INFO *ship, Real ox, Real oy);
extern void shot_homing(SHOT_INFO *info, SHIP_INFO *ship, Real speed);
extern void shot_3way(SHIP_INFO *info, SHOT_MGR *shot_mgr, Real ox, Real oy, double angle, Real speed);
extern void shot_5way(SHIP_INFO *info, SHOT_MGR *shot_mgr, Real ox, Real oy, double angle, Real speed);
extern void shot_chack_target(SHOT_MGR *mgr, SHIP_INFO *ship);
extern void shot_lost_target(SHOT_MGR *mgr, SHIP_INFO *ship);

#endif
